Attribute VB_Name = "vfw"
'*****************************************************************
'*  VB file:   VFW.bas    Traduccin de las funciones de fichero *
'*        de Microft vfw.h, el cual es parte de Win32.           *
'*                                                               *
'*                                                               *
'*                                                               *
'*                                                               *
'*                                                               *
'*****************************************************************
Option Explicit

Public Const WM_USER As Long = &H400
Public Const WM_CAP_START As Long = WM_USER

Public Const WM_CAP_DRIVER_CONNECT As Long = WM_CAP_START + 10
Public Const WM_CAP_SEQUENCE As Long = WM_CAP_START + 62
Public Const WM_CAP_SEQUENCE_NOFILE As Long = WM_CAP_START + 63
Public Const WM_CAP_GRAB_FRAME As Long = WM_CAP_START + 60
Public Const WM_CAP_EDIT_COPY As Long = WM_CAP_START + 30
Public Const WM_CAP_FILE_SAVEDIB As Long = WM_CAP_START + 25
Public Const WM_CAP_DRIVER_DISCONNECT As Long = WM_CAP_START + 11
Public Const WM_CAP_FILE_SET_CAPTURE_FILE = WM_CAP_START + 20
Public Const WM_CAP_SET_CALLBACK_VIDEOSTREAM As Long = WM_CAP_START + 6
Public Const WM_CAP_SET_CALLBACK_FRAME As Long = WM_CAP_START + 5
Public Const WM_CAP_SET_CALLBACK_STATUS = WM_CAP_START + 3
Public Const WM_CAP_GET_SEQUENCE_SETUP = WM_CAP_START + 65
Public Const WM_CAP_DRIVER_GET_NAME As Long = WM_CAP_START + 12
Public Const WM_CAP_SET_CALLBACK_ERROR = WM_CAP_START + 2
Public Const WM_CAP_FILE_SAVEAS As Long = WM_CAP_START + 23
Public Const WM_CAP_SET_PREVIEW As Long = WM_CAP_START + 50
Public Const DDF_DONTDRAW As Long = 17 '&O10
Public Const WM_CAP_GET_VIDEOFORMAT As Long = WM_CAP_START + 44
Public Const WM_CAP_SET_VIDEOFORMAT As Long = WM_CAP_START + 45
Public Const WM_CAP_SET_SEQUENCE_SETUP As Long = WM_CAP_START + 64
Public Const WM_CAP_STOP As Long = WM_CAP_START + 68
Public Const WM_CAP_DLG_VIDEOSOURCE = WM_CAP_START + 42

Public Const IDS_CAP_BEGIN = 300              '/* "Capture Start" */
Public Const IDS_CAP_END = 301                '/* "Capture End" */


'Estructura usada por la funcin capVideoStreamCallback
Public Type VIDEOHDR
    lpData As Long               'puntero a la direccion del buffer
                                 'de video
    dwBufferLength As Long       'tamao en bytes del buffer de video
    dwBytesUsed As Long          'bytes usados
    dwTimeCaptured As Long       'milisegundos desde que comenzo la captura
                                 '(stream)
    dwUser As Long               ' user-specific data
    dwFlags As Long              'banderas
    dwReserved(3) As Long        'reservado para driver, no se usa
End Type

   'Estructura que contiene los parametros de control del proceso de video
   'captura
Type CAPTUREPARMS
    dwRequestMicroSecPerFrame As Long       'frames capturados por microse_
                                            'gundo, por defecto es 66667,
                                            'que corresponde a 15 por segundo
    fMakeUserHitOKToCapture As Long         'user_initiated capture flag
    wPercentDropForError As Long            '// Give error msg if > (10%)
                                            'por defecto es 10
    fYield As Long                          'bandera yield
    dwIndexSize As Long                     'maximo indice de tamao en
                                            'frames (32K)
    wChunkGranularity As Long               '// Junk chunk granularity (2K)
    fUsingDOSMemory As Long                 '// Use DOS buffers?
    wNumVideoRequested As Long              '// # video buffers, If 0, autocalc
    fCaptureAudio As Long                   '// Capture audio?
    wNumAudioRequested As Long              '// # audio buffers, If 0, autocalc
    vKeyAbort As Long                       '// Virtual key causing abort
    fAbortLeftMouse As Long                 '// Abort on left mouse?
    fAbortRightMouse As Long                '// Abort on right mouse?
    fLimitEnabled As Long                   '// Use wTimeLimit?
    wTimeLimit As Long                      '// Seconds to capture
    fMCIControl As Long                     '// Use MCI video source?
    fStepMCIDevice As Long                  '// Step MCI device?
    dwMCIStartTime As Long                  '// Time to start in MS
    dwMCIStopTime As Long                   '// Time to stop in MS
    fStepCaptureAt2x As Long                '// Perform spatial averaging 2x
    wStepCaptureAverageFrames As Long       '// Temporal average n Frames
    dwAudioBufferSize As Long               '// Size of audio bufs (0 = default)
    fDisableWriteCache As Long              '// Attempt to disable write cache
End Type

    'Estructura que contiene informacin sobre las dimensiones y formato
    'de color de un mapa de bits independiente del dispositivo (DIB)
Public Type BITMAPINFOHEADER
   biSize As Long           'Especifica el nmero de bytes requerido por
                            'la estructura
   biWidth As Long          'especifica la anchura del mapa de bits en
                            'pixels
   biHeight As Long         'especifica la altura del mapa de bits en
                            'pixels.Si es positivo, el mapa de bits es
                            'un DIB "de abajo a arriba" y su origen es
                            'la esquina inferior izda
   biPlanes As Integer      'especifica el nmero de planos para el dis_
                            'dispositivo objetivo.Este valor debe ser 1
   biBitCount As Integer    'especifica el nmero de bits por pixel
   biCompression As Long    'especifica el tipo de compresin para un
                            'mapa de bits "de abajo a arriba" comprimido
   biSizeImage As Long      'especifica el tamao en bytes de la imagen
   biXPelsPerMeter As Long  'especifica la resolucin horizontal,en pixels
                            'por metro, del dispositivo destino para el
                            'mapa de bits
   biYPelsPerMeter As Long  'especifica la resolucin vertical, en pixels
                            'por metro,del dispositivo destino para el mapa
                            'de bits
   biClrUsed As Long        'especifica el numero de indices de color en la
                            'tabla de colores que se usan actualmente por el
                            'mapa de bits
   biClrImportant As Long   'especifica el nmero de ndices de colores que
                            'se consideran importantes para mostrar el mapa
                            'de bits. Se este valor es cero, todos los co_
                            'lores son importantes
                            
   
End Type

    'Estructura que define la dimensiones y la informacin sobre el color
    'para un mapa de bits independiente del dispositivo (DIB)
Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER   'Especifica una estructura
                                    'BITMAPINFOHEADER que contiene
                                    'informacin sobre las dimensiones
                                    'y formato de color de un DIB
                                  
    bmiColors() As Long  'especifica un array RGBQUAD o datos de doble
                         'palabra que define los colores del mapa de bits
End Type

    'Estructura que define el tipo, anchura, altura, formato de color y
    'valores de bit para un mapa de bits
Public Type BITMAP
      bmType As Long        'especifica el tipo de mapa de bits.Este
                            'miembro debe ser cero
      bmWidth As Long       'especifica la anchura del mapa de bits en
                            'pixels. La anchura debe ser mayor de cero
      bmHeight As Long      'especifica la altura del mapa de bits. La
                            'altura debe ser mayor de cero
      bmWidthBytes As Long  'especifica el nmero de bytes en cada lnea
                            'de rastreo
      bmPlanes As Integer   'especifica el nmero de planos de color
      bmBitsPixel As Integer 'especifica el nmero de bits requeridos para
                            'indicar el color de un pixel
      bmBits As Long        'puntero a los valores de los bits del mapa de
                            'de bits.
End Type



'Declaracion de la funcion que crea la ventana de captura

Declare Function capCreateCaptureWindow Lib "avicap32.dll" Alias "capCreateCaptureWindowA" _
                                        (ByVal lpszWindowName As String, _
                                        ByVal dwStyle As Long, _
                                        ByVal x As Long, _
                                        ByVal y As Long, _
                                        ByVal nWidth As Long, _
                                        ByVal nHeight As Long, _
                                        ByVal hwndParent As Long, _
                                        ByVal nID As Long) As Long 'devuelve HWND

    'Declaracin de la funcin para conseguir los drivers
Declare Function capGetDriverDescription Lib "avicap32.dll" Alias "capGetDriverDescriptionA" _
                                        (ByVal dwDriverIndex As Long, _
                                        ByVal lpszName As String, _
                                        ByVal cbName As Long, _
                                        ByVal lpszVer As String, _
                                        ByVal cbVer As Long) As Long 'returns C BOOL


'Declaracion de la funcion SendMessage

Private Declare Function SendMessageAsAny Lib "user32" Alias "SendMessageA" _
                                            (ByVal hWnd As Long, _
                                            ByVal wMsg As Long, _
                                            ByVal wParam As Long, _
                                            ByRef lParam As Any) As Long
Private Declare Function SendMessageAsString Lib "user32" Alias "SendMessageA" _
                                            (ByVal hWnd As Long, _
                                            ByVal wMsg As Long, _
                                            ByVal wParam As Long, _
                                            ByVal lParam As Any) As Long
Private Declare Function SendMessageAsLong Lib "user32" Alias "SendMessageA" _
                                            (ByVal hWnd As Long, _
                                            ByVal wMsg As Long, _
                                            ByVal wParam As Long, _
                                            ByVal lParam As Long) As Long
    'funcin para conectar los drivers
Function capDriverConnect(ByVal hCapWnd As Long, Optional ByVal i As Long = 0&) As Boolean
   capDriverConnect = SendMessageAsLong(hCapWnd, WM_CAP_DRIVER_CONNECT, i, 0&)
End Function
    'funcin para capturar video streaming grabandola en un .avi
Function capCaptureSequence(ByVal hWnd As Long) As Boolean
    capCaptureSequence = SendMessageAsLong(hWnd, WM_CAP_SEQUENCE, 0, 0&)
 End Function
    'funcin para capturar video streaming enviandola a un buffer de video
Function capCaptureSequenceNoFile(ByVal hWnd As Long) As Boolean
     capCaptureSequenceNoFile = SendMessageAsLong(hWnd, WM_CAP_SEQUENCE_NOFILE, 0&, 0&)
End Function
    'funcin para capturar frames enviandolos a un buffer
Function capGrabFrame(ByVal hWnd As Long) As Boolean
     capGrabFrame = SendMessageAsLong(hWnd, WM_CAP_GRAB_FRAME, 0, 0&)
End Function
    'funcin para copiar el contenido de un buffer de video frame
Function capEditCopy(ByVal hWnd As Long) As Boolean
     capEditCopy = SendMessageAsLong(hWnd, WM_CAP_EDIT_COPY, 0&, 0&)
End Function
    'funcin que guarda un dib
Function capFileSaveDIB(ByVal hCapWnd As Long, camino As String) As Boolean
   capFileSaveDIB = SendMessageAsString(hCapWnd, WM_CAP_FILE_SAVEDIB, 0&, camino)
End Function
    'funcin que desconecta los drivers
Function capDriverDisconnect(ByVal hCapWnd As Long) As Boolean
   capDriverDisconnect = SendMessageAsLong(hCapWnd, WM_CAP_DRIVER_DISCONNECT, 0&, 0&)
End Function
    'funcin que nos da el nombre del fichero de la video captura
Function capFileSetCaptureFile(ByVal lwnd As Long, szName As String) As Boolean
   capFileSetCaptureFile = SendMessageAsString(lwnd, WM_CAP_FILE_SET_CAPTURE_FILE, 0, szName)
End Function
    'funcin que nos indica cuando el buffer de video est lleno
Function capSetCallbackOnVideoStream(ByVal hCapWnd As Long, ByVal lpProc As Long) As Boolean
   capSetCallbackOnVideoStream = SendMessageAsLong(hCapWnd, WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0&, lpProc)
End Function
    'funcin que nos indica cuando un frame ha sido capturado
Function capSetCallbackOnFrame(ByVal hCapWnd As Long, ByVal lpProc As Long) As Boolean
   capSetCallbackOnFrame = SendMessageAsLong(hCapWnd, WM_CAP_SET_CALLBACK_FRAME, 0&, lpProc)
End Function
    'Callback que nos da diferenctes estados de la captura
Function capSetCallbackOnStatus(ByVal lwnd As Long, ByVal lpProc As Long) As Boolean
   capSetCallbackOnStatus = SendMessageAsLong(lwnd, WM_CAP_SET_CALLBACK_STATUS, 0, lpProc)
End Function
    'la funcin nos devuelve los parametros en curso de la video captura
Function capCaptureGetSetup(ByVal lwnd As Long, ByVal s As Long, ByVal wSize As Integer) As Boolean
   capCaptureGetSetup = SendMessageAsLong(lwnd, WM_CAP_GET_SEQUENCE_SETUP, wSize, s)
End Function
    'funcin que nos da el nombre del driver que est conectado
Function capDriverGetName(ByVal hCapWnd As Long) As String
   'returns driver name as VB string
   Dim szBuffer As String
   
   szBuffer = String$(128, 0)
   Call SendMessageAsString(hCapWnd, WM_CAP_DRIVER_GET_NAME, 128, szBuffer)
   capDriverGetName = Left$(szBuffer, InStr(szBuffer, vbNullChar) - 1)
End Function
    'funcin que guarda el videostream en un fichero .avi al cual tu
    'le das el nombre
Function capFileSaveAs(ByVal hCapWnd As Long, ByVal FilePath As String) As Boolean
   capFileSaveAs = SendMessageAsString(hCapWnd, WM_CAP_FILE_SAVEAS, 0&, FilePath)
End Function
    'funcin modo preview
Function capPreview(ByVal hCapWnd As Long, ByVal f As Boolean) As Boolean
   capPreview = SendMessageAsLong(hCapWnd, WM_CAP_SET_PREVIEW, -(f), 0&) 'convert the VB Boolean to a C BOOL with the - sign
End Function
    'funcin que nos da el tamao del formato
Function capGetVideoFormatSize(ByVal hCapWnd As Long) As Long
   capGetVideoFormatSize = SendMessageAsLong(hCapWnd, WM_CAP_GET_VIDEOFORMAT, 0&, 0&)
End Function
    'funcin que nos da el formato de la imagen
Function capGetVideoFormat(ByVal hCapWnd As Long, ByRef BmpFormat As BITMAPINFO, ByVal CapFormatSize As Long) As Long
   capGetVideoFormat = SendMessageAsAny(hCapWnd, WM_CAP_GET_VIDEOFORMAT, CapFormatSize, BmpFormat)
End Function
    'funcin que configura los parmetros del formato
Function capSetVideoFormat(ByVal hCapWnd As Long, ByRef BmpFormat As BITMAPINFO, ByVal CapFormatSize As Long) As Boolean
   capSetVideoFormat = SendMessageAsAny(hCapWnd, WM_CAP_SET_VIDEOFORMAT, CapFormatSize, BmpFormat)
End Function
    'funcin que configura los parmetros de captura
Function capCaptureSetSetup(ByVal lwnd As Long, ByVal s As Long, ByVal wSize As Integer) As Boolean
   capCaptureSetSetup = SendMessageAsLong(lwnd, WM_CAP_SET_SEQUENCE_SETUP, wSize, s)
End Function
    'funcin para parar la captura
 Function capCaptureStop(ByVal hCapWnd As Long) As Boolean
   capCaptureStop = SendMessageAsLong(hCapWnd, WM_CAP_STOP, 0&, 0&)
End Function
    'funcin que llama a Video Source de la cmara
Function capDlgVideoSource(ByVal lwnd As Long) As Boolean
   capDlgVideoSource = SendMessageAsLong(lwnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0)
End Function
